"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAllErrors = exports.getAllInstructions = exports.getAllDefinedTypes = exports.getAllAccounts = exports.getAllPdas = exports.rootNodeFromIdls = exports.rootNode = void 0;
const shared_1 = require("../shared");
const ProgramNode_1 = require("./ProgramNode");
function rootNode(programs) {
    return { kind: 'rootNode', programs };
}
exports.rootNode = rootNode;
function rootNodeFromIdls(idls) {
    const idlArray = Array.isArray(idls) ? idls : [idls];
    const programs = idlArray
        .map((idl) => (typeof idl === 'string' ? (0, shared_1.readJson)(idl) : idl))
        .map((idl) => (0, ProgramNode_1.programNodeFromIdl)(idl));
    return rootNode(programs);
}
exports.rootNodeFromIdls = rootNodeFromIdls;
function getAllPdas(node) {
    return node.programs.flatMap((program) => program.pdas);
}
exports.getAllPdas = getAllPdas;
function getAllAccounts(node) {
    return node.programs.flatMap((program) => program.accounts);
}
exports.getAllAccounts = getAllAccounts;
function getAllDefinedTypes(node) {
    return node.programs.flatMap((program) => program.definedTypes);
}
exports.getAllDefinedTypes = getAllDefinedTypes;
function getAllInstructions(node) {
    return node.programs.flatMap((program) => program.instructions);
}
exports.getAllInstructions = getAllInstructions;
function getAllErrors(node) {
    return node.programs.flatMap((program) => program.errors);
}
exports.getAllErrors = getAllErrors;
//# sourceMappingURL=RootNode.js.map