"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.INSTRUCTION_INPUT_VALUE_NODE = exports.CONTEXTUAL_VALUE_NODES = exports.REGISTERED_CONTEXTUAL_VALUE_NODE_KINDS = exports.REGISTERED_CONTEXTUAL_VALUE_NODES = exports.STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS = exports.STANDALONE_CONTEXTUAL_VALUE_NODES = void 0;
const utils_1 = require("../../shared/utils");
const ValueNode_1 = require("../valueNodes/ValueNode");
// Standalone Contextual Value Node Registration.
exports.STANDALONE_CONTEXTUAL_VALUE_NODES = {
    accountBumpValueNode: {},
    accountValueNode: {},
    argumentValueNode: {},
    conditionalValueNode: {},
    identityValueNode: {},
    payerValueNode: {},
    pdaValueNode: {},
    programIdValueNode: {},
    resolverValueNode: {},
};
exports.STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS = (0, utils_1.getNodeKinds)(exports.STANDALONE_CONTEXTUAL_VALUE_NODES);
// Contextual Value Node Registration.
exports.REGISTERED_CONTEXTUAL_VALUE_NODES = {
    ...exports.STANDALONE_CONTEXTUAL_VALUE_NODES,
    // The following are not valid standalone nodes.
    pdaSeedValueNode: {},
};
exports.REGISTERED_CONTEXTUAL_VALUE_NODE_KINDS = (0, utils_1.getNodeKinds)(exports.REGISTERED_CONTEXTUAL_VALUE_NODES);
exports.CONTEXTUAL_VALUE_NODES = exports.STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS;
exports.INSTRUCTION_INPUT_VALUE_NODE = [
    ...ValueNode_1.VALUE_NODES,
    ...exports.CONTEXTUAL_VALUE_NODES,
    'programLinkNode',
];
//# sourceMappingURL=ContextualValueNode.js.map