"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayTypeNodeFromIdl = exports.arrayTypeNode = void 0;
const sizeNodes_1 = require("../sizeNodes");
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function arrayTypeNode(item, size) {
    return {
        kind: 'arrayTypeNode',
        item,
        size: size !== null && size !== void 0 ? size : (0, sizeNodes_1.prefixedSizeNode)((0, NumberTypeNode_1.numberTypeNode)('u32')),
    };
}
exports.arrayTypeNode = arrayTypeNode;
function arrayTypeNodeFromIdl(idl) {
    if ('array' in idl) {
        const item = (0, TypeNode_1.createTypeNodeFromIdl)(idl.array[0]);
        return arrayTypeNode(item, (0, sizeNodes_1.fixedSizeNode)(idl.array[1]));
    }
    const item = (0, TypeNode_1.createTypeNodeFromIdl)(idl.vec);
    if (!idl.size)
        return arrayTypeNode(item);
    if (idl.size === 'remainder')
        return arrayTypeNode(item, (0, sizeNodes_1.remainderSizeNode)());
    return arrayTypeNode(item, (0, sizeNodes_1.prefixedSizeNode)((0, NumberTypeNode_1.numberTypeNode)(idl.size)));
}
exports.arrayTypeNodeFromIdl = arrayTypeNodeFromIdl;
//# sourceMappingURL=ArrayTypeNode.js.map