"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.optionTypeNodeFromIdl = exports.optionTypeNode = void 0;
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function optionTypeNode(item, options = {}) {
    var _a, _b, _c;
    return {
        kind: 'optionTypeNode',
        item,
        prefix: (_a = options.prefix) !== null && _a !== void 0 ? _a : (0, NumberTypeNode_1.numberTypeNode)('u8'),
        fixed: (_b = options.fixed) !== null && _b !== void 0 ? _b : false,
        idlOption: (_c = options.idlOption) !== null && _c !== void 0 ? _c : 'option',
    };
}
exports.optionTypeNode = optionTypeNode;
function optionTypeNodeFromIdl(idl) {
    const item = 'option' in idl ? idl.option : idl.coption;
    const defaultPrefix = (0, NumberTypeNode_1.numberTypeNode)('option' in idl ? 'u8' : 'u32');
    const defaultFixed = !('option' in idl);
    return optionTypeNode((0, TypeNode_1.createTypeNodeFromIdl)(item), {
        prefix: idl.prefix ? (0, NumberTypeNode_1.numberTypeNode)(idl.prefix) : defaultPrefix,
        fixed: idl.fixed !== undefined ? idl.fixed : defaultFixed,
        idlOption: 'option' in idl ? 'option' : 'coption',
    });
}
exports.optionTypeNodeFromIdl = optionTypeNodeFromIdl;
//# sourceMappingURL=OptionTypeNode.js.map