"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setTypeNodeFromIdl = exports.setTypeNode = void 0;
const sizeNodes_1 = require("../sizeNodes");
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function setTypeNode(item, size, idlSet) {
    return {
        kind: 'setTypeNode',
        item,
        size: size !== null && size !== void 0 ? size : (0, sizeNodes_1.prefixedSizeNode)((0, NumberTypeNode_1.numberTypeNode)('u32')),
        idlSet: idlSet !== null && idlSet !== void 0 ? idlSet : 'hashSet',
    };
}
exports.setTypeNode = setTypeNode;
function setTypeNodeFromIdl(idl) {
    const child = 'hashSet' in idl ? idl.hashSet : idl.bTreeSet;
    let size;
    if (idl.size === 'remainder') {
        size = (0, sizeNodes_1.remainderSizeNode)();
    }
    else if (typeof idl.size === 'number') {
        size = (0, sizeNodes_1.fixedSizeNode)(idl.size);
    }
    else if (idl.size) {
        size = (0, sizeNodes_1.prefixedSizeNode)((0, NumberTypeNode_1.numberTypeNode)(idl.size));
    }
    return setTypeNode((0, TypeNode_1.createTypeNodeFromIdl)(child), size, 'hashSet' in idl ? 'hashSet' : 'bTreeSet');
}
exports.setTypeNodeFromIdl = setTypeNodeFromIdl;
//# sourceMappingURL=SetTypeNode.js.map