"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountFetchHelpersFragment = void 0;
const common_1 = require("./common");
function getAccountFetchHelpersFragment(scope) {
    const { accountNode, typeManifest, nameApi, customAccountData } = scope;
    const accountDataName = nameApi.accountDataType(accountNode.name);
    const decoderFunctionFragment = customAccountData.has(accountNode.name)
        ? typeManifest.decoder.clone()
        : (0, common_1.fragment)(`${nameApi.decoderFunction(accountDataName)}()`);
    return (0, common_1.fragmentFromTemplate)('accountFetchHelpers.njk', {
        decoderFunction: decoderFunctionFragment.render,
        accountType: nameApi.accountType(accountNode.name),
        accountMaybeType: nameApi.accountMaybeType(accountNode.name),
        decodeFunction: nameApi.accountDecodeFunction(accountNode.name),
        fetchFunction: nameApi.accountFetchFunction(accountNode.name),
        fetchMaybeFunction: nameApi.accountFetchMaybeFunction(accountNode.name),
        fetchAllFunction: nameApi.accountFetchAllFunction(accountNode.name),
        fetchAllMaybeFunction: nameApi.accountFetchAllMaybeFunction(accountNode.name),
    })
        .mergeImportsWith(decoderFunctionFragment)
        .addImports('solanaAddresses', ['Address'])
        .addImports('solanaAccounts', [
        'assertAccountExists',
        'assertAccountsExist',
        'decodeAccount',
        'EncodedAccount',
        'fetchEncodedAccount',
        'fetchEncodedAccounts',
        'FetchAccountConfig',
        'FetchAccountsConfig',
        'MaybeEncodedAccount',
    ]);
}
exports.getAccountFetchHelpersFragment = getAccountFetchHelpersFragment;
//# sourceMappingURL=accountFetchHelpers.js.map