"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionDataFragment = void 0;
const common_1 = require("./common");
const typeWithCodec_1 = require("./typeWithCodec");
function getInstructionDataFragment(scope) {
    const { instructionNode, dataArgsManifest, nameApi, customInstructionData } = scope;
    if (instructionNode.arguments.length === 0 ||
        customInstructionData.has(instructionNode.name)) {
        return (0, common_1.fragment)('');
    }
    const instructionDataName = nameApi.instructionDataType(instructionNode.name);
    return (0, typeWithCodec_1.getTypeWithCodecFragment)({
        name: instructionDataName,
        manifest: dataArgsManifest,
        nameApi,
    });
}
exports.getInstructionDataFragment = getInstructionDataFragment;
//# sourceMappingURL=instructionData.js.map