"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeCodecFragment = void 0;
const common_1 = require("./common");
const typeDecoder_1 = require("./typeDecoder");
const typeEncoder_1 = require("./typeEncoder");
function getTypeCodecFragment(scope) {
    const { name, manifest, nameApi } = scope;
    return (0, common_1.mergeFragments)([
        (0, typeEncoder_1.getTypeEncoderFragment)({ ...scope, docs: scope.encoderDocs }),
        (0, typeDecoder_1.getTypeDecoderFragment)({ ...scope, docs: scope.decoderDocs }),
        (0, common_1.fragmentFromTemplate)('typeCodec.njk', {
            strictName: nameApi.dataType(name),
            looseName: nameApi.dataArgsType(name),
            codecFunction: nameApi.codecFunction(name),
            encoderFunction: nameApi.encoderFunction(name),
            decoderFunction: nameApi.decoderFunction(name),
            manifest,
            docs: scope.codecDocs,
        }).addImports('solanaCodecsCore', ['Codec', 'combineCodec']),
    ], (renders) => renders.join('\n\n'));
}
exports.getTypeCodecFragment = getTypeCodecFragment;
//# sourceMappingURL=typeCodec.js.map