"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeDataEnumHelpersFragment = void 0;
const nodes_1 = require("../../../nodes");
const common_1 = require("./common");
function getTypeDataEnumHelpersFragment(scope) {
    const { name, typeNode, nameApi } = scope;
    const isDataEnumNode = (0, nodes_1.isNode)(typeNode, 'enumTypeNode') && (0, nodes_1.isDataEnum)(typeNode);
    if (!isDataEnumNode) {
        return (0, common_1.fragment)('');
    }
    return (0, common_1.fragmentFromTemplate)('typeDataEnumHelpers.njk', {
        strictName: nameApi.dataType(name),
        looseName: nameApi.dataArgsType(name),
        dataEnumDiscriminator: nameApi.dataEnumDiscriminator(name),
        getVariant: (variant) => nameApi.dataEnumVariant(variant),
        dataEnumFunction: nameApi.dataEnumFunction(name),
        isDataEnumFunction: nameApi.isDataEnumFunction(name),
        typeNode,
    }).addImports('solanaCodecsDataStructures', [
        'GetDataEnumKindContent',
        'GetDataEnumKind',
    ]);
}
exports.getTypeDataEnumHelpersFragment = getTypeDataEnumHelpersFragment;
//# sourceMappingURL=typeDataEnumHelpers.js.map