"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefinedTypeNodesToExtract = exports.parseCustomDataOptions = void 0;
const nodes_1 = require("../../nodes");
const shared_1 = require("../../shared");
const parseCustomDataOptions = (customDataOptions, defaultSuffix) => new Map(customDataOptions.map((o) => {
    var _a, _b, _c;
    const options = typeof o === 'string' ? { name: o } : o;
    const importAs = (0, shared_1.mainCase)((_a = options.importAs) !== null && _a !== void 0 ? _a : `${options.name}${defaultSuffix}`);
    const importFrom = (_b = options.importFrom) !== null && _b !== void 0 ? _b : 'hooked';
    return [
        (0, shared_1.mainCase)(options.name),
        {
            importAs,
            importFrom,
            extractAs: options.extractAs ? (0, shared_1.mainCase)(options.extractAs) : importAs,
            extract: (_c = options.extract) !== null && _c !== void 0 ? _c : false,
            linkNode: (0, nodes_1.definedTypeLinkNode)(importAs, importFrom),
        },
    ];
}));
exports.parseCustomDataOptions = parseCustomDataOptions;
const getDefinedTypeNodesToExtract = (nodes, parsedCustomDataOptions) => nodes.flatMap((node) => {
    const options = parsedCustomDataOptions.get(node.name);
    if (!options || !options.extract)
        return [];
    if ((0, nodes_1.isNode)(node, 'accountNode')) {
        return [
            (0, nodes_1.definedTypeNode)({
                name: options.extractAs,
                type: { ...node.data },
                idlName: node.idlName,
            }),
        ];
    }
    return [
        (0, nodes_1.definedTypeNode)({
            name: options.extractAs,
            type: (0, nodes_1.structTypeNodeFromInstructionArgumentNodes)(node.arguments),
            idlName: node.idlName,
        }),
    ];
});
exports.getDefinedTypeNodesToExtract = getDefinedTypeNodesToExtract;
//# sourceMappingURL=customDataHelpers.js.map