"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGpaFieldsFromAccount = void 0;
const visitors_1 = require("../visitors");
function getGpaFieldsFromAccount(node, sizeVisitor) {
    let offset = 0;
    return node.data.fields.map((field) => {
        const fieldOffset = offset;
        if (offset !== null) {
            const newOffset = (0, visitors_1.visit)(field.type, sizeVisitor);
            offset = newOffset !== null ? offset + newOffset : null;
        }
        return { name: field.name, offset: fieldOffset, type: field.type };
    });
}
exports.getGpaFieldsFromAccount = getGpaFieldsFromAccount;
//# sourceMappingURL=GpaField.js.map