"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renameEnumNode = exports.renameStructNode = void 0;
const nodes_1 = require("../nodes");
function renameStructNode(node, map) {
    return (0, nodes_1.structTypeNode)(node.fields.map((field) => map[field.name]
        ? (0, nodes_1.structFieldTypeNode)({ ...field, name: map[field.name] })
        : field));
}
exports.renameStructNode = renameStructNode;
function renameEnumNode(node, map) {
    return (0, nodes_1.enumTypeNode)(node.variants.map((variant) => map[variant.name]
        ? renameEnumVariant(variant, map[variant.name])
        : variant), { ...node });
}
exports.renameEnumNode = renameEnumNode;
function renameEnumVariant(variant, newName) {
    if ((0, nodes_1.isNode)(variant, 'enumStructVariantTypeNode')) {
        return (0, nodes_1.enumStructVariantTypeNode)(newName, variant.struct);
    }
    if ((0, nodes_1.isNode)(variant, 'enumTupleVariantTypeNode')) {
        return (0, nodes_1.enumTupleVariantTypeNode)(newName, variant.tuple);
    }
    return (0, nodes_1.enumEmptyVariantTypeNode)(newName);
}
//# sourceMappingURL=renameHelpers.js.map