"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapVisitor = void 0;
const nodes_1 = require("../nodes");
const visitor_1 = require("./visitor");
function mapVisitor(visitor, map) {
    const registeredVisitFunctions = nodes_1.REGISTERED_NODE_KINDS.map(visitor_1.getVisitFunctionName);
    return Object.fromEntries(Object.keys(visitor).flatMap((key) => {
        if (!registeredVisitFunctions.includes(key)) {
            return [];
        }
        return [
            [
                key,
                (node) => map(visitor[key](node)),
            ],
        ];
    }));
}
exports.mapVisitor = mapVisitor;
//# sourceMappingURL=mapVisitor.js.map