"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setNumberWrappersVisitor = void 0;
const nodes_1 = require("../nodes");
const bottomUpTransformerVisitor_1 = require("./bottomUpTransformerVisitor");
function setNumberWrappersVisitor(map) {
    return (0, bottomUpTransformerVisitor_1.bottomUpTransformerVisitor)(Object.entries(map).map(([selectorStack, wrapper]) => ({
        select: `${selectorStack}.[numberTypeNode]`,
        transform: (node) => {
            (0, nodes_1.assertIsNode)(node, 'numberTypeNode');
            switch (wrapper.kind) {
                case 'DateTime':
                    return (0, nodes_1.dateTimeTypeNode)(node);
                case 'SolAmount':
                    return (0, nodes_1.solAmountTypeNode)(node);
                case 'Amount':
                    return (0, nodes_1.amountTypeNode)(node, wrapper.decimals, wrapper.unit);
                default:
                    throw new Error(`Invalid number wrapper kind: ${wrapper}`);
            }
        },
    })));
}
exports.setNumberWrappersVisitor = setNumberWrappersVisitor;
//# sourceMappingURL=setNumberWrappersVisitor.js.map