"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateErrorsVisitor = void 0;
const nodes_1 = require("../nodes");
const bottomUpTransformerVisitor_1 = require("./bottomUpTransformerVisitor");
function updateErrorsVisitor(map) {
    return (0, bottomUpTransformerVisitor_1.bottomUpTransformerVisitor)(Object.entries(map).map(([name, updates]) => ({
        select: `[errorNode]${name}`,
        transform: (node) => {
            (0, nodes_1.assertIsNode)(node, 'errorNode');
            if ('delete' in updates)
                return null;
            return (0, nodes_1.errorNode)({ ...node, ...updates });
        },
    })));
}
exports.updateErrorsVisitor = updateErrorsVisitor;
//# sourceMappingURL=updateErrorsVisitor.js.map