"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVisitFunctionName = exports.visitOrElse = exports.visit = void 0;
const nodes_1 = require("../nodes");
const shared_1 = require("../shared");
function visit(node, visitor) {
    const key = getVisitFunctionName(node.kind);
    return visitor[key](node);
}
exports.visit = visit;
function visitOrElse(node, visitor, fallback) {
    const key = getVisitFunctionName(node.kind);
    return (key in visitor ? visitor[key] : fallback)(node);
}
exports.visitOrElse = visitOrElse;
function getVisitFunctionName(node) {
    if (!nodes_1.REGISTERED_NODE_KINDS.includes(node)) {
        throw new shared_1.KinobiError(`Unrecognized node [${node}]`);
    }
    return `visit${(0, shared_1.pascalCase)(node.slice(0, -4))}`;
}
exports.getVisitFunctionName = getVisitFunctionName;
//# sourceMappingURL=visitor.js.map