import type { IdlAccount } from '../idl';
import { MainCaseString } from '../shared';
import { DiscriminatorNode } from './discriminatorNodes';
import { PdaLinkNode } from './linkNodes';
import { StructTypeNode } from './typeNodes';
export type AccountNode = {
    readonly kind: 'accountNode';
    readonly data: StructTypeNode;
    readonly pda?: PdaLinkNode;
    readonly discriminators?: DiscriminatorNode[];
    readonly name: MainCaseString;
    readonly idlName: string;
    readonly docs: string[];
    readonly size?: number | null;
};
export type AccountNodeInput = Omit<Partial<AccountNode>, 'kind' | 'name'> & {
    readonly name: string;
};
export declare function accountNode(input: AccountNodeInput): AccountNode;
export declare function accountNodeFromIdl(idl: Partial<IdlAccount>): AccountNode;
