import type { IdlDefinedType } from '../idl';
import { MainCaseString } from '../shared';
import { TypeNode } from './typeNodes/TypeNode';
export type DefinedTypeNode = {
    readonly kind: 'definedTypeNode';
    readonly type: TypeNode;
    readonly name: MainCaseString;
    readonly idlName: string;
    readonly docs: string[];
};
export type DefinedTypeNodeInput = {
    readonly name: string;
    readonly type: TypeNode;
    readonly idlName?: string;
    readonly docs?: string[];
};
export declare function definedTypeNode(input: DefinedTypeNodeInput): DefinedTypeNode;
export declare function definedTypeNodeFromIdl(idl: Partial<IdlDefinedType>): DefinedTypeNode;
