import type { IdlError } from '../idl';
import { MainCaseString, PartialExcept } from '../shared';
export type ErrorNode = {
    readonly kind: 'errorNode';
    readonly name: MainCaseString;
    readonly idlName: string;
    readonly code: number;
    readonly message: string;
    readonly docs: string[];
};
export type ErrorNodeInput = Omit<PartialExcept<ErrorNode, 'name' | 'code' | 'message'>, 'kind' | 'name'> & {
    readonly name: string;
};
export declare function errorNode(input: ErrorNodeInput): ErrorNode;
export declare function errorNodeFromIdl(idl: Partial<IdlError>): ErrorNode;
