import { IdlInstructionAccount } from '../idl';
import { MainCaseString, PartialExcept } from '../shared';
import { InstructionInputValueNode } from './contextualValueNodes';
export type InstructionAccountNode = {
    readonly kind: 'instructionAccountNode';
    readonly defaultValue?: InstructionInputValueNode;
    readonly name: MainCaseString;
    readonly isWritable: boolean;
    readonly isSigner: boolean | 'either';
    readonly isOptional: boolean;
    readonly docs: string[];
};
export type InstructionAccountNodeInput = Omit<PartialExcept<InstructionAccountNode, 'isWritable' | 'isSigner'>, 'kind' | 'name'> & {
    readonly name: string;
};
export declare function instructionAccountNode(input: InstructionAccountNodeInput): InstructionAccountNode;
export declare function instructionAccountNodeFromIdl(idl: IdlInstructionAccount): InstructionAccountNode;
