import { IdlInstructionArg } from '../idl';
import { MainCaseString } from '../shared';
import { InstructionInputValueNode } from './contextualValueNodes';
import { TypeNode } from './typeNodes';
export type InstructionArgumentNode = {
    readonly kind: 'instructionArgumentNode';
    readonly type: TypeNode;
    readonly defaultValue?: InstructionInputValueNode;
    readonly name: MainCaseString;
    readonly docs: string[];
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export type InstructionArgumentNodeInput = {
    readonly name: string;
    readonly type: TypeNode;
    readonly docs?: string[];
    readonly defaultValue?: InstructionInputValueNode;
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export declare function instructionArgumentNode(input: InstructionArgumentNodeInput): InstructionArgumentNode;
export declare function instructionArgumentNodeFromIdl(idl: IdlInstructionArg): InstructionArgumentNode;
export declare function structTypeNodeFromInstructionArgumentNodes(nodes: InstructionArgumentNode[]): import("./typeNodes").StructTypeNode;
export declare function structFieldTypeNodeFromInstructionArgumentNode(node: InstructionArgumentNode): import("./typeNodes").StructFieldTypeNode;
