import type { Idl } from '../idl';
import { MainCaseString, PartialExcept } from '../shared';
import { AccountNode } from './AccountNode';
import { DefinedTypeNode } from './DefinedTypeNode';
import { ErrorNode } from './ErrorNode';
import { InstructionNode } from './InstructionNode';
import { PdaNode } from './PdaNode';
export type ProgramNode = {
    readonly kind: 'programNode';
    readonly pdas: PdaNode[];
    readonly accounts: AccountNode[];
    readonly instructions: InstructionNode[];
    readonly definedTypes: DefinedTypeNode[];
    readonly errors: ErrorNode[];
    readonly name: MainCaseString;
    readonly prefix: MainCaseString;
    readonly publicKey: string;
    readonly version: string;
    readonly origin?: 'shank' | 'anchor';
};
export type ProgramNodeInput = Omit<PartialExcept<ProgramNode, 'publicKey'>, 'kind' | 'name' | 'prefix'> & {
    readonly name: string;
    readonly prefix?: string;
};
export declare function programNode(input: ProgramNodeInput): ProgramNode;
export declare function programNodeFromIdl(idl: Partial<Idl>): ProgramNode;
