import type { Idl } from '../idl';
import type { AccountNode } from './AccountNode';
import type { DefinedTypeNode } from './DefinedTypeNode';
import type { ErrorNode } from './ErrorNode';
import type { InstructionNode } from './InstructionNode';
import { PdaNode } from './PdaNode';
import { ProgramNode } from './ProgramNode';
export type IdlInputs = string | Partial<Idl> | (string | Partial<Idl>)[];
export type RootNode = {
    readonly kind: 'rootNode';
    readonly programs: ProgramNode[];
};
export declare function rootNode(programs: ProgramNode[]): RootNode;
export declare function rootNodeFromIdls(idls: IdlInputs): RootNode;
export declare function getAllPdas(node: RootNode): PdaNode[];
export declare function getAllAccounts(node: RootNode): AccountNode[];
export declare function getAllDefinedTypes(node: RootNode): DefinedTypeNode[];
export declare function getAllInstructions(node: RootNode): InstructionNode[];
export declare function getAllErrors(node: RootNode): ErrorNode[];
