import { ValueNode } from '../valueNodes';
import { AccountValueNode } from './AccountValueNode';
import { ArgumentValueNode } from './ArgumentValueNode';
import { InstructionInputValueNode } from './ContextualValueNode';
import { ResolverValueNode } from './ResolverValueNode';
export type ConditionalValueBranch = InstructionInputValueNode;
export declare const CONDITIONAL_VALUE_BRANCH_NODES: ("arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "programLinkNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type ConditionalValueNode = {
    readonly kind: 'conditionalValueNode';
    readonly condition: ResolverValueNode | AccountValueNode | ArgumentValueNode;
    readonly value?: ValueNode;
    readonly ifTrue?: ConditionalValueBranch;
    readonly ifFalse?: ConditionalValueBranch;
};
export declare function conditionalValueNode(input: {
    condition: ConditionalValueNode['condition'];
    value?: ConditionalValueNode['value'];
    ifTrue?: ConditionalValueNode['ifTrue'];
    ifFalse?: ConditionalValueNode['ifFalse'];
}): ConditionalValueNode;
