import type { ProgramLinkNode } from '../linkNodes/ProgramLinkNode';
import { ValueNode } from '../valueNodes/ValueNode';
import type { AccountBumpValueNode } from './AccountBumpValueNode';
import type { AccountValueNode } from './AccountValueNode';
import type { ArgumentValueNode } from './ArgumentValueNode';
import type { ConditionalValueNode } from './ConditionalValueNode';
import type { IdentityValueNode } from './IdentityValueNode';
import type { PayerValueNode } from './PayerValueNode';
import type { PdaSeedValueNode } from './PdaSeedValueNode';
import type { PdaValueNode } from './PdaValueNode';
import type { ProgramIdValueNode } from './ProgramIdValueNode';
import type { ResolverValueNode } from './ResolverValueNode';
export declare const STANDALONE_CONTEXTUAL_VALUE_NODES: {
    accountBumpValueNode: AccountBumpValueNode;
    accountValueNode: AccountValueNode;
    argumentValueNode: ArgumentValueNode;
    conditionalValueNode: ConditionalValueNode;
    identityValueNode: IdentityValueNode;
    payerValueNode: PayerValueNode;
    pdaValueNode: PdaValueNode;
    programIdValueNode: ProgramIdValueNode;
    resolverValueNode: ResolverValueNode;
};
export declare const STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS: ("accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type StandaloneContextualValueNodeKind = (typeof STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS)[number];
export type StandaloneContextualValueNode = (typeof STANDALONE_CONTEXTUAL_VALUE_NODES)[StandaloneContextualValueNodeKind];
export declare const REGISTERED_CONTEXTUAL_VALUE_NODES: {
    pdaSeedValueNode: PdaSeedValueNode;
    accountBumpValueNode: AccountBumpValueNode;
    accountValueNode: AccountValueNode;
    argumentValueNode: ArgumentValueNode;
    conditionalValueNode: ConditionalValueNode;
    identityValueNode: IdentityValueNode;
    payerValueNode: PayerValueNode;
    pdaValueNode: PdaValueNode;
    programIdValueNode: ProgramIdValueNode;
    resolverValueNode: ResolverValueNode;
};
export declare const REGISTERED_CONTEXTUAL_VALUE_NODE_KINDS: ("pdaSeedValueNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type RegisteredContextualValueNodeKind = (typeof REGISTERED_CONTEXTUAL_VALUE_NODE_KINDS)[number];
export type RegisteredContextualValueNode = (typeof REGISTERED_CONTEXTUAL_VALUE_NODES)[RegisteredContextualValueNodeKind];
export type ContextualValueNode = StandaloneContextualValueNode;
export declare const CONTEXTUAL_VALUE_NODES: ("accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type InstructionInputValueNode = ValueNode | ContextualValueNode | ProgramLinkNode;
export declare const INSTRUCTION_INPUT_VALUE_NODE: ("arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "programLinkNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
