import type { IdlTypeStructField } from '../../idl';
import { MainCaseString } from '../../shared';
import { ValueNode } from '../valueNodes';
import { TypeNode } from './TypeNode';
export type StructFieldTypeNode = {
    readonly kind: 'structFieldTypeNode';
    readonly type: TypeNode;
    readonly defaultValue?: ValueNode;
    readonly name: MainCaseString;
    readonly docs: string[];
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export type StructFieldTypeNodeInput = {
    readonly name: string;
    readonly type: TypeNode;
    readonly docs?: string[];
    readonly defaultValue?: ValueNode;
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export declare function structFieldTypeNode(input: StructFieldTypeNodeInput): StructFieldTypeNode;
export declare function structFieldTypeNodeFromIdl(idl: IdlTypeStructField): StructFieldTypeNode;
