import { IdlType } from '../../idl';
import { DefinedTypeLinkNode } from '../linkNodes/DefinedTypeLinkNode';
import { AmountTypeNode } from './AmountTypeNode';
import { ArrayTypeNode } from './ArrayTypeNode';
import { BooleanTypeNode } from './BooleanTypeNode';
import { BytesTypeNode } from './BytesTypeNode';
import { DateTimeTypeNode } from './DateTimeTypeNode';
import { EnumEmptyVariantTypeNode } from './EnumEmptyVariantTypeNode';
import { EnumStructVariantTypeNode } from './EnumStructVariantTypeNode';
import { EnumTupleVariantTypeNode } from './EnumTupleVariantTypeNode';
import { EnumTypeNode } from './EnumTypeNode';
import { MapTypeNode } from './MapTypeNode';
import { NumberTypeNode } from './NumberTypeNode';
import { OptionTypeNode } from './OptionTypeNode';
import { PublicKeyTypeNode } from './PublicKeyTypeNode';
import { SetTypeNode } from './SetTypeNode';
import { SolAmountTypeNode } from './SolAmountTypeNode';
import { StringTypeNode } from './StringTypeNode';
import { StructFieldTypeNode } from './StructFieldTypeNode';
import { StructTypeNode } from './StructTypeNode';
import { TupleTypeNode } from './TupleTypeNode';
export declare const STANDALONE_TYPE_NODES: {
    amountTypeNode: AmountTypeNode;
    arrayTypeNode: ArrayTypeNode;
    booleanTypeNode: BooleanTypeNode;
    bytesTypeNode: BytesTypeNode;
    dateTimeTypeNode: DateTimeTypeNode;
    enumTypeNode: EnumTypeNode;
    mapTypeNode: MapTypeNode;
    numberTypeNode: NumberTypeNode;
    optionTypeNode: OptionTypeNode;
    publicKeyTypeNode: PublicKeyTypeNode;
    setTypeNode: SetTypeNode;
    solAmountTypeNode: SolAmountTypeNode;
    stringTypeNode: StringTypeNode;
    structTypeNode: StructTypeNode;
    tupleTypeNode: TupleTypeNode;
};
export declare const STANDALONE_TYPE_NODE_KINDS: ("amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode")[];
export type StandaloneTypeNodeKind = (typeof STANDALONE_TYPE_NODE_KINDS)[number];
export type StandaloneTypeNode = (typeof STANDALONE_TYPE_NODES)[StandaloneTypeNodeKind];
export declare const REGISTERED_TYPE_NODES: {
    structFieldTypeNode: StructFieldTypeNode;
    enumEmptyVariantTypeNode: EnumEmptyVariantTypeNode;
    enumStructVariantTypeNode: EnumStructVariantTypeNode;
    enumTupleVariantTypeNode: EnumTupleVariantTypeNode;
    amountTypeNode: AmountTypeNode;
    arrayTypeNode: ArrayTypeNode;
    booleanTypeNode: BooleanTypeNode;
    bytesTypeNode: BytesTypeNode;
    dateTimeTypeNode: DateTimeTypeNode;
    enumTypeNode: EnumTypeNode;
    mapTypeNode: MapTypeNode;
    numberTypeNode: NumberTypeNode;
    optionTypeNode: OptionTypeNode;
    publicKeyTypeNode: PublicKeyTypeNode;
    setTypeNode: SetTypeNode;
    solAmountTypeNode: SolAmountTypeNode;
    stringTypeNode: StringTypeNode;
    structTypeNode: StructTypeNode;
    tupleTypeNode: TupleTypeNode;
};
export declare const REGISTERED_TYPE_NODE_KINDS: ("structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode")[];
export type RegisteredTypeNodeKind = (typeof REGISTERED_TYPE_NODE_KINDS)[number];
export type RegisteredTypeNode = (typeof REGISTERED_TYPE_NODES)[RegisteredTypeNodeKind];
export declare const TYPE_NODES: ("amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "definedTypeLinkNode")[];
export type TypeNodeKind = (typeof TYPE_NODES)[number];
export type TypeNode = StandaloneTypeNode | DefinedTypeLinkNode;
export declare const createTypeNodeFromIdl: (idlType: IdlType) => TypeNode;
