import type { ArrayValueNode } from './ArrayValueNode';
import type { BooleanValueNode } from './BooleanValueNode';
import type { EnumValueNode } from './EnumValueNode';
import type { MapEntryValueNode } from './MapEntryValueNode';
import type { MapValueNode } from './MapValueNode';
import type { NoneValueNode } from './NoneValueNode';
import type { NumberValueNode } from './NumberValueNode';
import type { PublicKeyValueNode } from './PublicKeyValueNode';
import type { SetValueNode } from './SetValueNode';
import type { SomeValueNode } from './SomeValueNode';
import type { StringValueNode } from './StringValueNode';
import type { StructFieldValueNode } from './StructFieldValueNode';
import type { StructValueNode } from './StructValueNode';
import type { TupleValueNode } from './TupleValueNode';
export declare const STANDALONE_VALUE_NODES: {
    arrayValueNode: ArrayValueNode;
    booleanValueNode: BooleanValueNode;
    enumValueNode: EnumValueNode;
    mapValueNode: MapValueNode;
    noneValueNode: NoneValueNode;
    numberValueNode: NumberValueNode;
    setValueNode: SetValueNode;
    someValueNode: SomeValueNode;
    structValueNode: StructValueNode;
    tupleValueNode: TupleValueNode;
    publicKeyValueNode: PublicKeyValueNode;
    stringValueNode: StringValueNode;
};
export declare const STANDALONE_VALUE_NODE_KINDS: ("arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode")[];
export type StandaloneValueNodeKind = (typeof STANDALONE_VALUE_NODE_KINDS)[number];
export type StandaloneValueNode = (typeof STANDALONE_VALUE_NODES)[StandaloneValueNodeKind];
export declare const REGISTERED_VALUE_NODES: {
    mapEntryValueNode: MapEntryValueNode;
    structFieldValueNode: StructFieldValueNode;
    arrayValueNode: ArrayValueNode;
    booleanValueNode: BooleanValueNode;
    enumValueNode: EnumValueNode;
    mapValueNode: MapValueNode;
    noneValueNode: NoneValueNode;
    numberValueNode: NumberValueNode;
    setValueNode: SetValueNode;
    someValueNode: SomeValueNode;
    structValueNode: StructValueNode;
    tupleValueNode: TupleValueNode;
    publicKeyValueNode: PublicKeyValueNode;
    stringValueNode: StringValueNode;
};
export declare const REGISTERED_VALUE_NODE_KINDS: ("arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "mapEntryValueNode" | "structFieldValueNode")[];
export type RegisteredValueNodeKind = (typeof REGISTERED_VALUE_NODE_KINDS)[number];
export type RegisteredValueNode = (typeof REGISTERED_VALUE_NODES)[RegisteredValueNodeKind];
export type ValueNode = StandaloneValueNode;
export declare const VALUE_NODES: ("arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode")[];
