import type { ImportFrom } from '../../shared';
import { Fragment } from './fragments';
import { TypeManifest } from './TypeManifest';
export declare class ImportMap {
    protected readonly _imports: Map<ImportFrom, Set<string>>;
    protected readonly _aliases: Map<ImportFrom, Record<string, string>>;
    add(module: ImportFrom, imports: string | string[] | Set<string>): ImportMap;
    remove(module: ImportFrom, imports: string | string[] | Set<string>): ImportMap;
    mergeWith(...others: (ImportMap | Fragment)[]): ImportMap;
    mergeWithManifest(manifest: TypeManifest): ImportMap;
    addAlias(module: ImportFrom, name: string, alias: string): ImportMap;
    isEmpty(): boolean;
    resolve(dependencies?: Record<ImportFrom, string>): Map<ImportFrom, Set<string>>;
    toString(dependencies?: Record<ImportFrom, string>): string;
}
