import { type DiscriminatorNode, type ProgramNode, type StructTypeNode } from '../../../nodes';
import type { GlobalFragmentScope } from '../getRenderMapVisitor';
import { Fragment } from './common';
/**
 * ```
 * if (data.length === 72) {
 *   return splTokenAccounts.TOKEN;
 * }
 *
 * if (memcmp(data, getU32Encoder().encode(42), offset)) {
 *   return splTokenAccounts.TOKEN;
 * }
 *
 * if (memcmp(data, new Uint8Array([1, 2, 3]), offset)) {
 *   return splTokenAccounts.TOKEN;
 * }
 * ```
 */
export declare function getDiscriminatorConditionFragment(scope: Pick<GlobalFragmentScope, 'nameApi' | 'typeManifestVisitor' | 'valueNodeVisitor'> & {
    programNode: ProgramNode;
    discriminators: DiscriminatorNode[];
    struct: StructTypeNode;
    dataName: string;
    ifTrue: string;
}): Fragment;
