import { Visitor } from '../../visitors';
import { TypeManifest } from './TypeManifest';
import { ParsedCustomDataOptions } from './customDataHelpers';
import { NameApi } from './nameTransformers';
import { ValueNodeVisitor } from './renderValueNodeVisitor';
export type TypeManifestVisitor = ReturnType<typeof getTypeManifestVisitor>;
export declare function getTypeManifestVisitor(input: {
    nameApi: NameApi;
    valueNodeVisitor: ValueNodeVisitor;
    customAccountData: ParsedCustomDataOptions;
    customInstructionData: ParsedCustomDataOptions;
    parentName?: {
        strict: string;
        loose: string;
    };
}): Visitor<TypeManifest, "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "definedTypeLinkNode" | "accountNode" | "instructionNode" | "definedTypeNode">;
