import { Visitor } from '../../visitors';
import { JavaScriptImportMap } from './JavaScriptImportMap';
import { ParsedCustomDataOptions } from './customDataHelpers';
import { renderValueNodeVisitor } from './renderValueNodeVisitor';
export type JavaScriptTypeManifest = {
    isEnum: boolean;
    strictType: string;
    strictImports: JavaScriptImportMap;
    looseType: string;
    looseImports: JavaScriptImportMap;
    serializer: string;
    serializerImports: JavaScriptImportMap;
};
export declare function getTypeManifestVisitor(input: {
    valueNodeVisitor: ReturnType<typeof renderValueNodeVisitor>;
    customAccountData: ParsedCustomDataOptions;
    customInstructionData: ParsedCustomDataOptions;
    parentName?: {
        strict: string;
        loose: string;
    };
}): Visitor<JavaScriptTypeManifest, "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "definedTypeLinkNode" | "accountNode" | "instructionNode" | "definedTypeNode">;
