import { RustImportMap } from './RustImportMap';
export type RustTypeManifest = {
    type: string;
    imports: RustImportMap;
    nestedStructs: string[];
};
export declare function getTypeManifestVisitor(): {
    setParentName: (name: string | null) => void;
    setNestedStruct: (value: boolean) => void;
    visitArrayValue: (node: import("../../nodes").ArrayValueNode) => RustTypeManifest;
    visitBooleanValue: (node: import("../../nodes").BooleanValueNode) => RustTypeManifest;
    visitEnumValue: (node: import("../../nodes").EnumValueNode) => RustTypeManifest;
    visitMapValue: (node: import("../../nodes").MapValueNode) => RustTypeManifest;
    visitNoneValue: (node: import("../../nodes").NoneValueNode) => RustTypeManifest;
    visitNumberValue: (node: import("../../nodes").NumberValueNode) => RustTypeManifest;
    visitSetValue: (node: import("../../nodes").SetValueNode) => RustTypeManifest;
    visitSomeValue: (node: import("../../nodes").SomeValueNode) => RustTypeManifest;
    visitStructValue: (node: import("../../nodes").StructValueNode) => RustTypeManifest;
    visitTupleValue: (node: import("../../nodes").TupleValueNode) => RustTypeManifest;
    visitPublicKeyValue: (node: import("../../nodes").PublicKeyValueNode) => RustTypeManifest;
    visitStringValue: (node: import("../../nodes").StringValueNode) => RustTypeManifest;
    visitMapEntryValue: (node: import("../../nodes").MapEntryValueNode) => RustTypeManifest;
    visitStructFieldValue: (node: import("../../nodes").StructFieldValueNode) => RustTypeManifest;
    visitStructFieldType: (node: import("../../nodes").StructFieldTypeNode) => RustTypeManifest;
    visitEnumEmptyVariantType: (node: import("../../nodes").EnumEmptyVariantTypeNode) => RustTypeManifest;
    visitEnumStructVariantType: (node: import("../../nodes").EnumStructVariantTypeNode) => RustTypeManifest;
    visitEnumTupleVariantType: (node: import("../../nodes").EnumTupleVariantTypeNode) => RustTypeManifest;
    visitAmountType: (node: import("../../nodes").AmountTypeNode) => RustTypeManifest;
    visitArrayType: (node: import("../../nodes").ArrayTypeNode) => RustTypeManifest;
    visitBooleanType: (node: import("../../nodes").BooleanTypeNode) => RustTypeManifest;
    visitBytesType: (node: import("../../nodes").BytesTypeNode) => RustTypeManifest;
    visitDateTimeType: (node: import("../../nodes").DateTimeTypeNode) => RustTypeManifest;
    visitEnumType: (node: import("../../nodes").EnumTypeNode) => RustTypeManifest;
    visitMapType: (node: import("../../nodes").MapTypeNode) => RustTypeManifest;
    visitNumberType: (node: import("../../nodes").NumberTypeNode) => RustTypeManifest;
    visitOptionType: (node: import("../../nodes").OptionTypeNode) => RustTypeManifest;
    visitPublicKeyType: (node: import("../../nodes").PublicKeyTypeNode) => RustTypeManifest;
    visitSetType: (node: import("../../nodes").SetTypeNode) => RustTypeManifest;
    visitSolAmountType: (node: import("../../nodes").SolAmountTypeNode) => RustTypeManifest;
    visitStringType: (node: import("../../nodes").StringTypeNode) => RustTypeManifest;
    visitStructType: (node: import("../../nodes").StructTypeNode) => RustTypeManifest;
    visitTupleType: (node: import("../../nodes").TupleTypeNode) => RustTypeManifest;
    visitFixedSize: (node: import("../../nodes").FixedSizeNode) => RustTypeManifest;
    visitRemainderSize: (node: import("../../nodes").RemainderSizeNode) => RustTypeManifest;
    visitPrefixedSize: (node: import("../../nodes").PrefixedSizeNode) => RustTypeManifest;
    visitConstantPdaSeed: (node: import("../../nodes").ConstantPdaSeedNode) => RustTypeManifest;
    visitProgramIdPdaSeed: (node: import("../../nodes").ProgramIdPdaSeedNode) => RustTypeManifest;
    visitVariablePdaSeed: (node: import("../../nodes").VariablePdaSeedNode) => RustTypeManifest;
    visitProgramLink: (node: import("../../nodes").ProgramLinkNode) => RustTypeManifest;
    visitPdaLink: (node: import("../../nodes").PdaLinkNode) => RustTypeManifest;
    visitAccountLink: (node: import("../../nodes").AccountLinkNode) => RustTypeManifest;
    visitDefinedTypeLink: (node: import("../../nodes").DefinedTypeLinkNode) => RustTypeManifest;
    visitByteDiscriminator: (node: import("../../nodes").ByteDiscriminatorNode) => RustTypeManifest;
    visitFieldDiscriminator: (node: import("../../nodes").FieldDiscriminatorNode) => RustTypeManifest;
    visitSizeDiscriminator: (node: import("../../nodes").SizeDiscriminatorNode) => RustTypeManifest;
    visitPdaSeedValue: (node: import("../../nodes").PdaSeedValueNode) => RustTypeManifest;
    visitAccountBumpValue: (node: import("../../nodes").AccountBumpValueNode) => RustTypeManifest;
    visitAccountValue: (node: import("../../nodes").AccountValueNode) => RustTypeManifest;
    visitArgumentValue: (node: import("../../nodes").ArgumentValueNode) => RustTypeManifest;
    visitConditionalValue: (node: import("../../nodes").ConditionalValueNode) => RustTypeManifest;
    visitIdentityValue: (node: import("../../nodes").IdentityValueNode) => RustTypeManifest;
    visitPayerValue: (node: import("../../nodes").PayerValueNode) => RustTypeManifest;
    visitPdaValue: (node: import("../../nodes").PdaValueNode) => RustTypeManifest;
    visitProgramIdValue: (node: import("../../nodes").ProgramIdValueNode) => RustTypeManifest;
    visitResolverValue: (node: import("../../nodes").ResolverValueNode) => RustTypeManifest;
    visitRoot: (node: import("../../nodes").RootNode) => RustTypeManifest;
    visitProgram: (node: import("../../nodes").ProgramNode) => RustTypeManifest;
    visitPda: (node: import("../../nodes").PdaNode) => RustTypeManifest;
    visitAccount: (node: import("../../nodes").AccountNode) => RustTypeManifest;
    visitInstructionAccount: (node: import("../../nodes").InstructionAccountNode) => RustTypeManifest;
    visitInstructionArgument: (node: import("../../nodes").InstructionArgumentNode) => RustTypeManifest;
    visitInstructionByteDelta: (node: import("../../nodes").InstructionByteDeltaNode) => RustTypeManifest;
    visitInstruction: (node: import("../../nodes").InstructionNode) => RustTypeManifest;
    visitInstructionRemainingAccounts: (node: import("../../nodes").InstructionRemainingAccountsNode) => RustTypeManifest;
    visitError: (node: import("../../nodes").ErrorNode) => RustTypeManifest;
    visitDefinedType: (node: import("../../nodes").DefinedTypeNode) => RustTypeManifest;
};
