import { ConfigureOptions } from 'nunjucks';
export type MainCaseString = string & {
    readonly __mainCaseString: unique symbol;
};
export type PickPartial<T, K extends keyof T> = Omit<T, K> & Partial<Pick<T, K>>;
export type PartialExcept<T, K extends keyof T> = Pick<T, K> & Partial<Omit<T, K>>;
export type Mutable<T> = {
    -readonly [P in keyof T]: T[P];
};
export type DontInfer<T> = T extends any ? T : never;
export declare function getNodeKinds<TNode, TObj extends Record<string, TNode>>(obj: TObj): (keyof TObj)[];
export declare function capitalize(str: string): string;
export declare function titleCase(str: string): string;
export declare function pascalCase(str: string): string;
export declare function camelCase(str: string): string;
export declare function kebabCase(str: string): string;
export declare function snakeCase(str: string): string;
export declare function mainCase(str: string): MainCaseString;
export declare function jsDocblock(docs: string[]): string;
export declare function rustDocblock(docs: string[]): string;
export declare function readJson<T extends object>(value: string): T;
export declare const createDirectory: (path: string) => void;
export declare const createFile: (path: string, content: string) => void;
export declare const resolveTemplate: (directory: string, file: string, context?: object, options?: ConfigureOptions) => string;
export declare const deleteFolder: (path: string) => void;
