import { Node, NodeKind } from '../nodes';
import { NodeSelector, NodeStack } from '../shared';
import { Visitor } from './visitor';
export type BottomUpNodeTransformer<TNode extends Node = Node> = (node: TNode, stack: NodeStack) => Node | null;
export type BottomUpNodeTransformerWithSelector<TNode extends Node = Node> = {
    select: NodeSelector | NodeSelector[];
    transform: BottomUpNodeTransformer<TNode>;
};
export declare function bottomUpTransformerVisitor<TNodeKind extends NodeKind = NodeKind>(transformers: (BottomUpNodeTransformer | BottomUpNodeTransformerWithSelector)[], nodeKeys?: TNodeKind[]): Visitor<Node | null, TNodeKind>;
