import { InstructionInputValueNode } from '../nodes/contextualValueNodes';
export type InstructionAccountDefaultRule = {
    /** The name of the instruction account or a pattern to match on it. */
    account: string | RegExp;
    /** The default value to assign to it. */
    defaultValue: InstructionInputValueNode;
    /** @defaultValue Defaults to searching accounts on all instructions. */
    instruction?: string;
    /** @defaultValue `false`. */
    ignoreIfOptional?: boolean;
};
export declare const DEFAULT_INSTRUCTION_ACCOUNT_DEFAULT_RULES: InstructionAccountDefaultRule[];
export declare function setInstructionAccountDefaultValuesVisitor(rules: InstructionAccountDefaultRule[]): import("./visitor").Visitor<import("../nodes").Node, "rootNode" | "programNode" | "instructionNode">;
