import { Node, NodeKind } from '../nodes';
import { NodeSelector, NodeStack } from '../shared';
import { Visitor } from './visitor';
export type TopDownNodeTransformer<TNode extends Node = Node> = <T extends TNode = TNode>(node: T, stack: NodeStack) => T | null;
export type TopDownNodeTransformerWithSelector<TNode extends Node = Node> = {
    select: NodeSelector | NodeSelector[];
    transform: TopDownNodeTransformer<TNode>;
};
export declare function topDownTransformerVisitor<TNodeKind extends NodeKind = NodeKind>(transformers: (TopDownNodeTransformer | TopDownNodeTransformerWithSelector)[], nodeKeys?: TNodeKind[]): Visitor<Node | null, TNodeKind>;
