import { AccountNodeInput, PdaSeedNode } from '../nodes';
export type AccountUpdates = {
    delete: true;
} | (Partial<Omit<AccountNodeInput, 'data'>> & {
    data?: Record<string, string>;
    seeds?: PdaSeedNode[];
});
export declare function updateAccountsVisitor(map: Record<string, AccountUpdates>): import("./visitor").Visitor<import("../nodes").Node | null, "arrayValueNode" | "booleanValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "mapEntryValueNode" | "structFieldValueNode" | "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "publicKeyTypeNode" | "setTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "fixedSizeNode" | "remainderSizeNode" | "prefixedSizeNode" | "constantPdaSeedNode" | "programIdPdaSeedNode" | "variablePdaSeedNode" | "programLinkNode" | "pdaLinkNode" | "accountLinkNode" | "definedTypeLinkNode" | "byteDiscriminatorNode" | "fieldDiscriminatorNode" | "sizeDiscriminatorNode" | "pdaSeedValueNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode" | "rootNode" | "programNode" | "pdaNode" | "accountNode" | "instructionAccountNode" | "instructionArgumentNode" | "instructionByteDeltaNode" | "instructionNode" | "instructionRemainingAccountsNode" | "errorNode" | "definedTypeNode">;
