import { NodeKind } from '../nodes';
import { interceptVisitor } from './interceptVisitor';
import { nonNullableIdentityVisitor } from './nonNullableIdentityVisitor';

export function removeDocsVisitor<TNodeKind extends NodeKind = NodeKind>(
  nodeKeys?: TNodeKind[]
) {
  return interceptVisitor(
    nonNullableIdentityVisitor(nodeKeys),
    (node, next) => {
      if ('docs' in node) {
        return { ...node, docs: [] };
      }
      return next(node);
    }
  );
}
